#! /bin/sh
#
# Autor: Kinga Izdebska
# Przeznaczenie: skrypt uatwiajcy instalacj oprogramowania
#                zmodyfikowanego i napisanego w ramach pracy 
#                magisterskiej ,,Indeksowanie dokumentw w jzyku 
#                polskim w systemie LATEX2e''
#
#

#CDROM=/mnt/cdrom
CDROM=/f1/instalki/PRACA/

ZALECANA_WERSJA="GNU Emacs 21.0.99.1"

echo "----------------------------------------------------"
echo "                   WITAM!"
echo
echo "Uruchomiony skrypt pomoe Ci w zainstalowaniu:"
echo "sam"
echo "dvispell"
echo "dvisprep"
echo "sambag"
echo "oraz skopiowaniu zmodyfikowanych/nowych  plikw "
echo "Reftex'a: reftex.el, reftex-index,el, reftex-vars.el,"
echo "polish-sort.el"
echo
echo "----------------------------------------------------"

echo "Czy chcesz kontynuowa (t/n)?"
read ODP
while   [ x"$ODP" != "xt" ] &&  [ x"$ODP" != "xn" ]; do
echo "Odpowiedz t/n!"
echo "Czy chcesz kontynuowa (t/n)?";
read ODP;
done

if [ $ODP = "n" ] ; then 
    echo "DOWIDZENIA!"
    exit 0; 
fi

echo "Podaj katalog z plikami do instalacji ($CDROM):"
read ODP

CDROM=${ODP:=$CDROM}

echo "Podaj ciek do emacsa, z ktorego korzystasz"
echo  "(jeli nie jest w zmiennej PATH):" 
read EMACSPATH

if ! [ x"$EMACSPATH" = x ] ;then
    RUNEMACS=${EMACSPATH}"/";
fi


echo "Podaj nazw programu, ktry podajesz uruchamiajc emacs'a"
echo "(jeli inny ni emacs)"
read EMACSPROGRAM

RUNEMACS=${RUNEMACS}${EMACSPROGRAM:=emacs} 

echo "Sprawdzenie wersji emacsa $RUNEMACS ..."

if [ x"$EMACSPATH" = x ]; then
    RUNEMACS=`type $EMACSPROGRAM`;
    i=0
    for x in $RUNEMACS; do
	i=$(($i+1));
	if [ $i = 3 ]; then break; fi;
    done
    RUNEMACS=$x
    if [ x"$RUNEMACS" = x ]; then
	echo "Nie znaleziono  $EMACSPROGRAM!"
	echo "Przed ponownym uruchomieniem zainstaluj emacsa!!!"
	exit 1;	
    fi
fi

if ! [ -a $RUNEMACS ]; then
    echo "Nie znaleziono  $RUNEMACS!"
    echo "Przed ponownym uruchomieniem zainstaluj emacsa!!!"
    exit 1;
fi


EMACSPARAMS=" --version"

WERSJA=`$RUNEMACS$EMACSPARAMS | head -1`

 
if ! [ x"$WERSJA" = x"$ZALECANA_WERSJA" ]; then
    echo "Wersja Twojego Emacsa"
    echo $WERSJA
    echo "jest inna ni zalecana"
    echo $ZALECANA_WERSJA;
    echo "Czy chcesz kontynuowa (t/n)?"
    read ODP
    if  [ x"$ODP" = x"n" ] ; then
	exit 1;
    fi
fi

echo "Czy masz zainstalowany analizator morfologiczny sam (t/n)?"
read ODP

while   [ x"$ODP" != "xt" ] &&  [ x"$ODP" != "xn" ]; do
    echo "Odpowiedz t/n!"
    echo "Czy masz zainstalowany analizator morfologiczny sam (t/n)?"
    read ODP;
done

case $ODP in
"t") SAMINSTALLED=1;;
"n") SAMINSTALLED=0;;
esac


if [ $SAMINSTALLED = 1 ] ;then
    SAMPATH=`type sam`;
    i=0
    for x in $SAMPATH; do
	i=$(($i+1));
	if [ $i = 3 ]; then break; fi;
    done
    SAMPATH=$x
    CHECKSAM=0
    if [ x"$SAMPATH" = x ] || ! [ -a $SAMPATH ]; then
	echo "---------------------------------------------"
	echo "          OSTRZEENIE!!!           "
	echo "---------------------------------------------"
	echo "cieka do programu sam jest nieznana. Naley"
	echo "doda go do PATH po uruchomieniu emacs'a "
	echo "korzystajcego ze zmodyfikowanych plikw "
	echo "Reftexa nada zmiennej reftex-sam-path-to-executables     "
	echo "odpowiedni warto."
	#echo "Czy chcesz sprawdzi ciek do sama?"
	#read ODP
	#while   [ x"$ODP" != "xt" ] &&  [ x"$ODP" != "xn" ]; do
	#    echo "Odpowiedz t/n!"
	#    echo "Czy masz zainstalowany analizator morfologiczny sam?"
	#    read ODP;
	#done
        #
	#case $ODP in
        #  "t") CHECKSAM=1;;
        #  "n") CHECKSAM=0;;
	#esac
    else
	if [ x$SAM = x ] ;then
	    echo "---------------------------------------------"
	    echo "          OSTRZEENIE!!!           "
	    echo "---------------------------------------------"
	    echo "Zmienna rodowiskowa SAM, ktra powinna  wskazywa"
	    echo "katalog, w ktrym znajduj si pliki z baz  dla "
	    echo "sama jest pusta! Ustaw j przed uruchomieniem "
	    echo "programu!"
	else
	   echo "Zmienna rodowiskowa SAM, ktra powinna  wskazywa"
	   echo "katalog, w ktrym znajduj si pliki z baz ma warto:"
	   echo "$SAM" 
	fi	    
    fi    
    #SPRAWDZENIE CIEZKI SAMA
    #	    ????
else
#instalacja SAMA
    while [ $SAMINSTALLED = 0 ]; do
    echo "Instalacja sama"
    echo "Podaj katalog gdzie chcesz umieci pliki sama (~/SAM99):"
    read SAMDIR
    SAMDIR=${SAMDIR:=$HOME"/SAM99"}
    if ! [ -d $SAMDIR ]; then
	echo "Katalog $SAMDIR nie istnieje"
	if mkdir $SAMDIR  ; then
	    echo "Zosta utworzony";
	else
	    echo "Nie udao si utworzy nowego katalogu $SAMDIR"
	    echo "Czy chcesz jeszcze raz sprbowa zainstalowa sama (t/n)?"
            read ODP
            while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
		echo "Odpowiedz t/n!"
		echo "Czy chcesz jeszcze raz sprbowa zainstalowa sama (t/n)?"
		read ODP
	    done
	    case $ODP in
               "t") continue;;
                "n") exit 1;;
            esac
	fi
    fi
    echo "Kopiowanie plikw do instalacji sama"
    while ! [ -r $CDROM/sam34.tar.gz ]; do
	echo "Plik $CDROM/sam34.tar.gz nie istnieje!!"
	echo "Czy chcesz przerwa instalacj (t/n)?"
	read ODP;
	while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
		echo "Odpowiedz t/n!"
		echo "Czy chcesz przerwa instalacj (t/n)?"
		read ODP
	 done
	 case $ODP in
               "t") exit 1;;
                "n") echo "Podaj cieke do plikw instalacyjnych (/mnt/cdrom):"
		     read OPD
		     CDROM=${OPD:=$CDROM};;
            esac
    done

    pushd $SAMDIR
    if ! cp -fr $CDROM/sam34.tar.gz $SAMDIR/ ; then
	echo "Operacja kopiowania < cp -fr $CDROM/sam34.tar.gz $SAMDIR >"
	echo "zakoczya si niepowodzeniem"
	popd
	exit 1;
    else
	echo "Kopiowanie plikw zakoczone";
    fi
    if !  gunzip $SAMDIR/sam34.tar.gz ; then
	echo "Operacja dekompresji <gunzip $SAMDIR/sam34.tar.gz>"
	echo "zakoczya si niepowodzeniem"
	popd
	exit 1;
    else
	echo "Dekompresja zakoczona"
    fi
    if ! tar -xf  $SAMDIR/sam34.tar ; then
	echo "Operacja <tar -xf  $SAMDIR/sam34.tar >"
	echo "zakoczya si niepowodzeniem"
	popd
	exit 1;
    else
	echo "Roztarowanie zakoczone"
    fi	
    rm -fr $SAMDIR/sam34.tar
    popd
    echo "W katalogu $SAMDIR Zosta utworzony plik wykonywalny sam34"
    echo "---------------------------------------------------------------"
    echo "          KILKA UWAG                                           "
    echo "---------------------------------------------------------------"
    echo "W zmodyfikowanych plikach reftex'a program sam uruchamiany     "
    echo "jest jako <sam>, nie <sam34>. Mona                            "
    echo "1. Po uruchomieniu emasc'a ustawi warto zmiennej "
    echo "   <reftex-sam-path-to-executable> na $SAMDIR, "
    echo "   a warto zmiennej <reftex-sam-program-name> na sam34"
    echo "albo"
    echo "2. Umieci program sam34 albo link do niego w katalogu       "
    echo "   ze zminnej PATH pod nazw sam"


    echo "Czy chesz skopiowa sam34 do katalogu z PATH (t/n)?"
    read ODP
    while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
	echo "Odpowiedz t/n!"
	echo "Czy chesz skopiowa sam34 do innego katalogu z PATH(t/n)?"
	read ODP
    done
    case $ODP in
	"n") break;;
	"t") echo "Podaj katalog (/usr/local/bin):"
	    read ODP
	    SAMDEST=${ODP:="/usr/local/bin"}
	    if cp -fr $SAMDIR/sam34 $SAMDEST/sam ; then
		echo "Skopiowano $SAMDIR/sam34 do $SAMDEST/sam"
		chmod a+x $SAMDEST/sam
	    else
		echo "Kopiowanie  $SAMDIR/sam34 do $SAMDEST/sam zakoczone bdem"
	    fi
	    if ! chmod a+x $SAMDEST/sam ; then
		echo "Nie duao si nadanie samowi praw do wykonywania"
	    fi
	    ;;
    esac
    SAMINSTALLED=1
    echo "---------------------------------------------"
    echo "          OSTRZEENIE!!!           "
    echo "---------------------------------------------"
    echo "Pamitaj o zmiennej rodowiskowej SAM, ktra "
    echo "powinna  wskazywa katalog, w ktrym znajduj "
    echo "si pliki z baz  dla sama. Ustaw j przed   "
    echo "uruchomieniem na $SAMDIR/BAZA/ !!!"
    done
fi




echo "Czy masz zainstalowany dvispell i dvisprep (t/n)?"
read ODP

while   [ x"$ODP" != "xt" ] &&  [ x"$ODP" != "xn" ]; do
    echo "Odpowiedz t/n!"
    echo "Czy masz zainstalowany dvispell i dvisprep (t/n)?"
    read ODP;
done

case $ODP in
"t") DVISPELLINSTALLED=1;;
"n") DVISPELLINSTALLED=0;;
esac

if [ $DVISPELLINSTALLED = 0 ]; then
   echo "Podaj katalog gdzie chcesz umieci DVISPELL (~/DVISPELL2001):"
    read DVISPELLDIR
    DVISPELLDIR=${DVISPELLDIR:=$HOME"/DVISPELL2001"}
    if ! [ -d $DVISPELLDIR ]; then
	echo "Katalog $DVISPELLDIR nie istnieje"
	if mkdir $DVISPELLDIR  ; then
	    echo "Zosta utworzony";
	else
	    echo "Nie udao si utworzy nowego katalogu $DVISPELLDIR"
	    echo "Czy chcesz jeszcze raz sprbowa zainstalowa dvispell (t/n)?"
            read ODP
            while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
		echo "Odpowiedz t/n!"
		echo "Czy chcesz jeszcze raz sprbowa zainstalowa dvispell (t/n)?"
		read ODP
	    done
	    case $ODP in
               "t") continue;;
                "n") exit 1;;
            esac
	fi
    fi
    echo "Kopiowanie plikw do instalacji dvispell"
    while ! [ -r $CDROM/dvispell.tar.gz ]; do
	echo "Plik $CDROM/dvispell.tar.gz nie istnieje!!"
	echo "Czy chcesz przerwa instalacj (t/n)?"
	read ODP;
	while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
		echo "Odpowiedz t/n!"
		echo "Czy chcesz przerwa instalacj (t/n)?"
		read ODP
	done
	case $ODP in
	     "t") exit 1;;
	     "n") echo "Podaj cieke do plikw instalacyjnych (/mnt/cdrom):"
		 read OPD
		     CDROM=${OPD:=$CDROM};;
	esac
    done

    pushd $DVISPELLDIR
    if ! cp -fr $CDROM/dvispell.tar.gz . ; then
	echo "Operacja kopiowania < cp -fr $CDROM/dvispell.tar.gz $DVISPELLDIR >"
	echo "zakoczya si niepowodzeniem"
	popd
	exit 1;
    else
	echo "Kopiowanie plikw zakoczone";
    fi
    if !  gunzip dvispell.tar.gz ; then
	echo "Operacja dekompresji <gunzip $DVISPELLDIR/dvispell.tar.gz>"
	echo "zakoczya si niepowodzeniem"
	popd
	exit 1;
    else
	echo "Dekompresja zakoczona"
    fi
    if ! tar -xf  dvispell.tar ; then
	echo "Operacja <tar -xf  $DVISPELLDIR/dvispell.tar >"
	echo "zakoczya si niepowodzeniem"
	popd
	exit 1;
    else
	echo "Roztarowanie zakoczone"
    fi	
    rm -fr dvispell.tar
    if ! configure ; then
	echo "Nie powiodo si wykonanie configure do instalacji dvispell!!!"
	exit 1;
    fi
    if ! make dvispell; then
	echo "Nie powioda si kompilacja dvispell!!!"
	exit 1;
    fi
    if ! make dvisprep; then
	echo "Nie powioda si kompilacja dvisprep!!!"
	exit 1;
    fi
    popd

    echo "Utworzono pliku wykonywalne dvispell i dvisprep"
    echo "Naley umieci progam dvispell oraz dvisperep w katalogu z PATH"
    echo "Czy chesz skopiowa je do PATH (t/n)?"
    read ODP
            while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
		echo "Odpowiedz t/n!"
		echo "Czy chesz skopiowa je do PATH (t/n)?"
		read ODP
	    done
	    case $ODP in
               "n") ;;
               "t") echo "Podaj katalog, gdzie chesz je skopiowa (/usr/local/bin):"
		    read ODP
		    DVISPELLINSTALLDIR=${ODP:="/usr/local/bin"}
		    if ! install -c $DVISPELLDIR/dvispell $DVISPELLINSTALLDIR  ; then
			echo "Instalacja dvispell zakoczya si bdem"
			exit 1
		    else
			echo "Program dvispell zosta skoipiowany do katalogu $DVISPELLINSTALLDIR"
		    fi;
		    if ! install -c $DVISPELLDIR/dvisprep $DVISPELLINSTALLDIR  ; then
			echo "Instalacja dvisprep zakoczya si bdem"
			exit 1
		    else
			echo "Program dvisprep zosta skopiowany do katalogu $DVISPELLINSTALLDIR"
		    fi;
		    ;;
            esac 
fi

echo "Do prawidowego dziaania programu dvispell potrzebne s pliki binarne "
echo "parametrami (pliki DSB) . W Reftex'u jako poczkowa wartoc wskazujca"
echo "katalog, w ktrym powinny si znajdowa pliki DSB proponowany jest:"
echo "/usr/share/DSB. Jeli uytkownik umieci pliki w innym katalogu to "
echo "pamita, aby po uruchomieniu emacs'a zmodyfikowa warto zmiennej"
echo "reftex-dvispell-dsb-path"
echo
echo "Czy chcesz utowrzy pliki dsb (t/n)?"
read ODP
while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
    echo "Odpowiedz t/n!"
    echo "Czy chesz utowrzy pliki dsb (t/n)?"
    read ODP
done

if [ x"$ODP" = x"t" ]; then
    echo "Podaj katalog, gdzie chcesz skopiowa pliki DSB (/usr/share/DSB/):"
    read ODP
    DSBDIR=${ODP:="/usr/share/DSB"}
    POD=${DVISPELLDIR:="????"}
    echo "Podaj katalog, gdzie znajduj si pliki polish.dsi oraz plain.dsi ($POD):"
    read ODP
    DSIDIR=${ODP:="$POD"}
    if ! [ -r $DSIDIR/plain.dsi ] || ! [ -r $DSIDIR/polish.dsi ]; then
	echo "Nie zosta znaleziony plik $DSIDIR/plain.dsi albo $DSIDIR/polish.dsi!!!"
	exit 1;
    else
	if ! [ -d $DSBDIR ]; then
	    echo "Katalog $DSBDIR nie istnieje"
	    if mkdir $DSBDIR  ; then
		echo "Zosta utworzony";
	    else
		echo "Nie udao si utworzy nowego katalogu $DSBDIR"
		exit 1;
	    fi
	fi
	pushd $DSIDIR
	echo "dvisprep plain.dsi $DSBDIR/plain"
	if ! dvisprep plain.dsi $DSBDIR/plain ; then
	    echo "Nie udao si utworzy pliku z parametraami plain.dsb"
	    popd 
	    exit 1;
	fi
	echo "dvisprep polish.dsi $DSBDIR/polish"
	if ! dvisprep polish.dsi $DSBDIR/polish ; then
	    echo "Nie udao si utworzy pliku z parametrami polish.dsb"
	    popd 
	    exit 1;
	fi
	popd 
    fi
fi


echo
echo  "Zmodyfikowane pliki reftex'a mog zosta umieszczone w dowolnym katalogu"
echo  "Trzeba tylko pamita, aby doda odpowiedni ciek do load-path podczas "
echo  "uruchamiania emacsa (np. wpisujc do .emacs: "
echo  "(setq load-path (cons nowa-cieka load-path))"
echo
echo "Podaj katalog, gdzie chesz skopiowa zmodyfikowane pliki reftex'a:"
read ODP

while [ x"$ODP" = x ] ; do
    echo "Podaj katalog, gdzie chesz skopiowa zmodyfikowane pliki reftex'a:"
    read ODP;
done

REFTEXDIR=$ODP

if ! [ -d $REFTEXDIR ]; then
    echo "Katalog $REFTEXDIR nie istnieje"
    echo "Czy chesz go utworzy (t/n)?"
    read ODP
    while [ x"$ODP" != x"t" ] &&  [ x"$ODP" != x"n" ] ;do
	echo "Odpowiedz t/n!"
	echo "Czy chesz utworzy katalog $REFTEXDIR(t/n)?"
	read ODP
    done
    case $ODP in
	"n") exit 1;;
	"t") 
	    if ! mkdir $REFTEXDIR ; then
		echo "Nie udao si utworzy katalog $REFTEXDIR!!!"
		exit 1;
	    fi;;
	esac
fi

echo "Kopiowanie pliku reftex.el"
if ! cp $CDROM/reftex.el "$REFTEXDIR"/ ; then
    echo "Nie udao si wykona operacji  cp $CDROM/reftex.el $REFTEXDIR!!!"
    exit 1;
fi
echo "Kopiowanie pliku reftex-vars.el"
if ! cp $CDROM/reftex-vars.el "$REFTEXDIR"/ ; then
    echo "Nie udao si wykona operacji  cp $CDROM/reftex-vars.el $REFTEXDIR!!!"
    exit 1;
fi
echo "Kopiowanie pliku reftex-index.el"
if ! cp $CDROM/reftex-index.el "$REFTEXDIR"/ ; then
    echo "Nie udao si wykona operacji  cp $CDROM/reftex-index.el $REFTEXDIR!!!"
    exit 1;
fi

echo "Kopiowanie pliku polish-sort.el"
if ! cp $CDROM/polish-sort.el "$REFTEXDIR"/ ; then
    echo "Nie udao si wykona operacji  cp $CDROM/polish-sort.el $REFTEXDIR!!!"
    exit 1;
fi

chmod a+x $REFTEXDIR/reftex.el
chmod a+x $REFTEXDIR/reftex-vars.el
chmod a+x $REFTEXDIR/reftex-index.el
chmod a+x $REFTEXDIR/polish-sort.el

echo "Instalacja programu sambag"

echo "Podaj katalog, gdzie chesz umieci program sambag (usr/local/bin/):"
read ODP
SAMBAGDIR=${ODP:="usr/local/bin/"}
echo "Kopiowanie pliku sambag.pl"
if ! cp $CDROM/sambag.pl $SAMBAGDIR/sambag ; then
    echo "Nie udao si wykona operacji  cp $CDROM/sambag.pl $SAMBAGDIRambag!!!"
    exit 1;
fi
chmod a+x $SAMBAGDIR/sambag 

echo "------------------------------------------------------"
echo "        KONIEC!!!!!"
echo "------------------------------------------------------"


